Index: http.pike
===================================================================
RCS file: /cvs/Roxen/2.0/server/protocols/http.pike,v
retrieving revision 1.228
retrieving revision 1.231
diff -u -u -r1.228 -r1.231
--- http.pike	2000/03/27 13:19:06	1.228
+++ http.pike	2000/07/21 22:58:30	1.231
@@ -2,7 +2,7 @@
 // Modified by Francesco Chemolli to add throttling capabilities.
 // Copyright  1996 - 2000, Roxen IS.
 
-constant cvs_version = "$Id: http.pike,v 1.228 2000/03/27 13:19:06 jhs Exp $";
+constant cvs_version = "$Id: http.pike,v 1.231 2000/07/21 22:58:30 js Exp $";
 
 #define MAGIC_ERROR
 
@@ -668,6 +668,12 @@
   REQUEST_WERR(sprintf("After query scan:%O", f));
 
   f = http_decode_string( f );
+
+  // f is sent to Unix API's that take NUL-terminated strings...
+  int i;
+  if((i = search(f, "\0")) != -1)
+    f = f[..i-1];
+  
   string prf = f[1..1];
   if (prf == "<" && sscanf(f, "/<%s>/%s", a, f)==2)
   {
@@ -1737,8 +1743,14 @@
 	else
           head_string += h+": "+heads[h]+"\r\n";
 
-      if(file->len > -1)
+      if(file->len > -1) {
 	head_string += "Content-Length: "+ file->len +"\r\n";
+	if (file->len == 0)
+	  // Some browsers, e.g. Netscape 4.7, doesn't trust a zero
+	  // content length when using keep-alive. So let's force a
+	  // close in that case.
+	  misc->connection = "close";
+      }
       else
 	misc->connection = "close";
 
@@ -1999,6 +2011,7 @@
   c->prestate = prestate;
   c->supports = supports;
   c->config = config;
+  c->client_var = client_var;
 
   c->remoteaddr = remoteaddr;
   c->host = host;
